<link rel="import" href="bower_components/polymer/polymer.html">
<link rel="import" href="bower_components/paper-card/paper-card.html">
<link rel="import" href="bower_components/iron-flex-layout/iron-flex-layout.html">
<link rel="import" href="bower_components/iron-flex-layout/iron-flex-layout-classes.html">
<link rel="import" href="custom-popup.html">

<dom-module id="tiny-author-books">
    <template>
        <style include="iron-flex iron-flex-layout"></style>

        <style>
            :host {
                width: 100%;
                position: relative;
                display: block;
            }

            paper-card.book-card {
                margin: 3px;
                height: 120px;
                box-sizing: border-box;
            }

            div.book-card-cover {
                width: 120px;
                min-width: 120px;
                display: inline-block;
                background-size: contain;
                background-repeat: no-repeat;
                background-color: #dde;
                background-position-x: center;
            }

            div.book-card-info {
                height: 100%;
                display: inline-block;
                padding-right: 10px;
            }

            div.book-card-info-title {
                font-weight: bold;
            }

            div.book-list-content {
                position: relative;
                width: 100%;
                justify-content: space-around;
            }
        </style>

        <div class="book-list-content flex layout horizontal wrap arround justified">
            <paper-button on-click="handleClick"> {{author}} </paper-button>
            <template is="dom-if" if="{{show}}">
              <rsat-popup pos="center" show="{{show}}" backdrop="true">
                <paper-button on-click="hide" style="float: right"> Fermer </paper-button>
                <div class="book-card-info flex">
                  <h3> Livres de {{author}} </h3>
                  <template is="dom-repeat" items="{{books}}">
                    <template is="dom-if" if="{{_isEqualTo(author, item.author)}}">
                      <paper-card class="book-card layout horizontal">
                          <div class="book-card-cover" style="background-image: url(data:image/jpeg;base64,{{item.img.data}})"></div>
                          <div class="book-card-info flex">
                              <div class="book-card-info-title">{{item.title}}</div>
                              <div class="book-card-info-price">{{item.price}}€</div>
                          </div>
                      </paper-card>
                    </template>
                  </template>
                </div>
              </rsat-popup>
            </template>
        </div>
    </template>

    <script>
    class TinyAuthorBooks extends Polymer.Element {
        static get is() {
            return "tiny-author-books";
        }

        static get properties() {
            return {
                books: {
                    type: Array,
                    notify: true
                },
                author: {
                  type: Object,
                  notify: true
                },
                show: {
                  type: Object,
                  notify: true,
                  value: false
                }
            }
        }

        handleClick(e) {
          this.show = true;
        }

        hide(e) {
          this.show = false;
        }

        _isEqualTo(author, author2) {
          return author == author2;
        }
    }
    customElements.define(TinyAuthorBooks.is, TinyAuthorBooks);
    </script>
</dom-module>
